/* Nilo - A Network boot loader.

   Copyright (C) 1999 Free Software Foundation, Inc.

This file is part of Nilo.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

#ifndef __TAGGED_H__
#define __TAGGED_H__

/* This is the include generated by configuring */
#include "niloconfig.h"

/* Define the PXE types */
#include "pxe_types.h"

/* Define the TFTP data structures */
#include "tftp.h"

/* Define some structures used by tftp loader */

#define	TAG_MAGIC	0x1B031336L

struct imgheader {
    unsigned long magic;
    unsigned char length;
    unsigned char r[3];
    struct { unsigned short bx, ds; } location;
    struct { unsigned short ip, cs; } execaddr;
};

union infoblock {
    unsigned short s[256];
    unsigned long l[128];
    struct imgheader i;
};

struct segheader {
    unsigned char length;
    unsigned char vendortag;
    unsigned char reserved;
    unsigned char flags;
    unsigned long loadaddr;
    unsigned long imglength;
    unsigned long memlength;
};

#define	vlength(a)	(((a) & 0xF0) >> 2)

extern void handle_block(int blockno, char *data, int blocksize);

#endif /* __TAGGED_H__ */


